package generalidades;

import java.util.ArrayList;
import java.util.List;

/**
 * Clase que representa un objeto definido por una lista de puntos y una lista
 * de etiquetas.
 * 
 * @author Jos Manuel Ponce
 */
public class ConjuntoTresListas
{
	/**
	 * Lista de puntos.
	 */
	List<Integer> listaPuntos = new ArrayList<Integer>();
	
	/**
	 * Lista de alturas de etiquetas.
	 */
	List<Integer> alturas = new ArrayList<Integer>();
	
	/**
	 * Lista de anchuras de etiquetas.
	 */
	List<Integer> anchuras = new ArrayList<Integer>();
	
	/**
	 * Constructor por defecto.
	 */
	public ConjuntoTresListas()
	{
		super();
	}
	
	/**
	 * Constructor por parmetros.
	 * 
	 * @param listPuntos
	 *            Lista de puntos
	 * @param listAlturas
	 *            Lista de alturas de etiquetas
	 * @param listAnchuras
	 *            Lista de anchuras de etiquetas
	 */
	public ConjuntoTresListas(List<Integer> listPuntos,
			List<Integer> listAlturas, List<Integer> listAnchuras)
	{
		this.listaPuntos = listPuntos;
		this.alturas = listAlturas;
		this.anchuras = listAnchuras;
	}
	
	/**
	 * Obtiene el Lista de puntos.
	 * 
	 * @return listaPuntos Lista de puntos
	 */
	public List<Integer> getListaPuntos()
	{
		return listaPuntos;
	}
	
	/**
	 * Establece el Lista de puntos.
	 * 
	 * @param listaPuntos
	 *            listaPuntos Lista de puntos
	 */
	public void setListaPuntos(List<Integer> listaPuntos)
	{
		this.listaPuntos = listaPuntos;
	}

	/**
	 * Obtiene el Lista de alturas de etiquetas.
	 * @return alturas Lista de alturas de etiquetas
	 */
	public List<Integer> getAlturas()
	{
		return alturas;
	}

	/**
	 * Establece el Lista de alturas de etiquetas.
	 * @param alturas alturas Lista de alturas de etiquetas
	 */
	public void setAlturas(List<Integer> alturas)
	{
		this.alturas = alturas;
	}

	/**
	 * Obtiene el Lista de anchuras de etiquetas.
	 * @return anchuras Lista de anchuras de etiquetas
	 */
	public List<Integer> getAnchuras()
	{
		return anchuras;
	}

	/**
	 * Establece el Lista de anchuras de etiquetas.
	 * @param anchuras anchuras Lista de anchuras de etiquetas
	 */
	public void setAnchuras(List<Integer> anchuras)
	{
		this.anchuras = anchuras;
	}
	
	
}
