package generalidades;

/**
 * Clase que almacena las constantes que se utilizarn en la aplicacin.
 * 
 * @author Jos Manuel Ponce
 */
public class Constantes
{
	
	/**
	 * Constante que indica (Top Left) que la etiqueta se sita arriba a la izquierda del punto.
	 */
	public static final String POS_ARRIBA_IZQUIERDA = "TL";
	
	/**
	 * Constante que indica (Top Right) que la etiqueta se sita arriba a la derecha del punto.
	 */
	public static final String POS_ARRIBA_DERECHA = "TR";
	
	/**
	 * Constante que indica (Bottom Left) que la etiqueta se sita abajo a la izquierda del punto.
	 */
	public static final String POS_ABAJO_IZQUIERDA = "BL";
	
	/**
	 * Constante que indica (Bottom Right) que la etiqueta se sita abajo a la derecha del punto.
	 */
	public static final String POS_ABAJO_DERECHA = "BR";
	
	/**
	 * Constante que indica (Top) que la etiqueta se sita encima del punto.
	 */
	public static final String POS_ARRIBA = "TT";
	
	/**
	 * Constante que indica (Bottom) que la etiqueta se sita debajo del punto.
	 */
	public static final String POS_ABAJO = "BB";
	
	/**
	 * Constante que indica (Right) que la etiqueta se sita a la derecha del punto.
	 */
	public static final String POS_DERECHA = "RR";
	
	/**
	 * Constante que indica (Left) que la etiqueta se sita a la izquierda del punto.
	 */
	public static final String POS_IZQUIERDA = "LL";
	
	// problema H-4P
	
	/**
	 * Constante con el texto que aparece en la cabecera del problema al que se
	 * refiere.
	 */
	public static final String CABECERA_H_4P = "######################################################################\n"
			+ "############ EJECUCIN DEL PROBLEMA DE ETIQUETADO H-4P ###############\n"
			+ "######################################################################\n";
	
	/**
	 * Constante con la informacin necesaria acerca del problema al que se
	 * refiere.
	 */
	public static final String INFO_H_4P = "\nDada una lnea horizontal, se va a proceder a etiquetar N puntos con\n"
			+ "sus respectivas N etiquetas. Tanto el conjunto de puntos, como el de etiquetas\n"
			+ "sern introducidos ambos por el usuario cuando se solicite por pantalla\n"
			+ "o mediante un fichero de texto que tambin introducir el usuario.\n"
			+ "La salida que proporcionar el programa ser una lista de posiciones\n"
			+ "tales que, el primer elemento de la lista corresponder a la posicin\n"
			+ "de la primera etiqueta respecto del primer punto; el segundo elemento\n"
			+ "de la lista de posiciones corresponder a la posicin de la segunda\n"
			+ "etiqueta respecto del segundo punto; y as sucesivamente.\n"
			+ "Las posiciones relativas sern las siguientes:\n"
			+ "     TL -> (Top Left) la etiqueta se sita arriba a la izquierda del punto\n"
			+ "     TR -> (Top Right) la etiqueta se sita arriba a la derecha del punto\n"
			+ "     BL -> (Bottom Left) la etiqueta se sita abajo a la izquierda del punto\n"
			+ "     BL -> (Bottom Right) la etiqueta se sita abajo a la derecha del punto\n"
			+ "Si el problema no tiene solucin, se omitir todo o parte del listado anterior y se indicar\n"
			+ "la imposibilidad de etiquetar sobre los puntos dados.\n";
	
	/**
	 * Constante con la informacin necesaria acerca del formato de un fichero
	 * de entrada de datos para el problema que representa.
	 */
	public static final String INFO_FICHERO_H_4P = "Debe crear un fichero de texto y guardarlo con el nombre \"entrada_H-4P.txt\" en la ubicacin\n"
			+ "donde se encuentra el proyecto. El formato del fichero ser el siguiente:\n"
			+ "- La primera lnea es un nmero entero que representa el total de puntos a etiquetar (N).\n"
			+ "- Las siguientes N lneas sern tambin nmeros enteros que representan los puntos.\n"
			+ "- Las N ltimas sern igualmente nmeros enteros que representan las etiquetas.\n"
			+ "* No se permiten lneas en blanco ni nmeros separados por espacios.\n";
	
// problema H-4S-1C
	
	/**
	 * Constante con el texto que aparece en la cabecera del problema al que se
	 * refiere.
	 */
	public static final String CABECERA_H_4S_1C = "#########################################################################\n"
			+ "############ EJECUCIN DEL PROBLEMA DE ETIQUETADO H-4S-1C ###############\n"
			+ "#########################################################################\n";
	
	/**
	 * Constante con la informacin necesaria acerca del problema al que se
	 * refiere.
	 */
	public static final String INFO_H_4S_1C = "\nDada una lnea horizontal, se va a proceder a etiquetar N puntos con\n"
			+ "sus respectivas N etiquetas cuadradas. Tanto el conjunto de puntos como la dimensin de\n"
			+ "las etiquetas sern introducidos ambos por el usuario cuando se solicite por pantalla\n"
			+ "o mediante un fichero de texto que tambin introducir el usuario.\n"
			+ "La salida que proporcionar el programa ser una lista de posiciones\n"
			+ "tales que, el primer elemento de la lista corresponder a la posicin\n"
			+ "de la primera etiqueta respecto del primer punto; el segundo elemento\n"
			+ "de la lista de posiciones corresponder a la posicin de la segunda\n"
			+ "etiqueta respecto del segundo punto; y as sucesivamente.\n"
			+ "Las posiciones relativas sern las siguientes:\n"
			+ "     TL -> (Top Left) la etiqueta se sita arriba a la izquierda del punto\n"
			+ "     TR -> (Top Right) la etiqueta se sita arriba a la derecha del punto\n"
			+ "     BL -> (Bottom Left) la etiqueta se sita abajo a la izquierda del punto\n"
			+ "     BL -> (Bottom Right) la etiqueta se sita abajo a la derecha del punto\n"
			+ "     TT -> (Top) la etiqueta se sita encima del punto\n"
			+ "     BB -> (Bottom) la etiqueta se sita debajo del punto\n"
			+ "Si el problema no tiene solucin, se omitir todo o parte del listado anterior y se indicar\n"
			+ "la imposibilidad de etiquetar sobre los puntos dados.\n";
	
	/**
	 * Constante con la informacin necesaria acerca del formato de un fichero
	 * de entrada de datos para el problema que representa.
	 */
	public static final String INFO_FICHERO_H_4S_1C = "Debe crear un fichero de texto y guardarlo con el nombre \"entrada_H-4S-1C.txt\" en la ubicacin\n"
			+ "donde se encuentra el proyecto. El formato del fichero ser el siguiente:\n"
			+ "- La primera lnea es un nmero entero que representa el total de puntos a etiquetar (N).\n"
			+ "- Las siguientes N lneas sern tambin nmeros enteros que representan los puntos.\n"
			+ "- La ltima lnea contiene la dimensin (cuadrada) de las etiquetas.\n"
			+ "* No se permiten lneas en blanco ni nmeros separados por espacios.\n";
	
// problema H-4S
	
	/**
	 * Constante con el texto que aparece en la cabecera del problema al que se
	 * refiere.
	 */
	public static final String CABECERA_H_4S = "######################################################################\n"
			+ "############ EJECUCIN DEL PROBLEMA DE ETIQUETADO H-4S ###############\n"
			+ "######################################################################\n";
	
	/**
	 * Constante con la informacin necesaria acerca del problema al que se
	 * refiere.
	 */
	public static final String INFO_H_4S = "\nDada una lnea horizontal, se va a proceder a etiquetar N puntos con\n"
			+ "sus respectivas N etiquetas. Tanto el conjunto de puntos como la dimensin de las\n"
			+ "etiquetas sern introducidos ambos por el usuario cuando se solicite por pantalla\n"
			+ "o mediante un fichero de texto que tambin introducir el usuario.\n"
			+ "La salida que proporcionar el programa ser una lista de posiciones\n"
			+ "tales que, el primer elemento de la lista corresponder a la posicin\n"
			+ "de la primera etiqueta respecto del primer punto; el segundo elemento\n"
			+ "de la lista de posiciones corresponder a la posicin de la segunda\n"
			+ "etiqueta respecto del segundo punto; y as sucesivamente.\n"
			+ "Las posiciones relativas sern las siguientes:\n"
			+ "     TL -> (Top Left) la etiqueta se sita arriba a la izquierda del punto\n"
			+ "     TR -> (Top Right) la etiqueta se sita arriba a la derecha del punto\n"
			+ "     BL -> (Bottom Left) la etiqueta se sita abajo a la izquierda del punto\n"
			+ "     BL -> (Bottom Right) la etiqueta se sita abajo a la derecha del punto\n"
			+ "     TT -> (Top) la etiqueta se sita encima del punto\n"
			+ "     BB -> (Bottom) la etiqueta se sita debajo del punto\n"
			+ "Si el problema no tiene solucin, se omitir todo o parte del listado anterior y se indicar\n"
			+ "la imposibilidad de etiquetar sobre los puntos dados.\n";
	
	/**
	 * Constante con la informacin necesaria acerca del formato de un fichero
	 * de entrada de datos para el problema que representa.
	 */
	public static final String INFO_FICHERO_H_4S = "Debe crear un fichero de texto y guardarlo con el nombre \"entrada_H-4S-1C.txt\" en la ubicacin\n"
			+ "donde se encuentra el proyecto. El formato del fichero ser el siguiente:\n"
			+ "- La primera lnea es un nmero entero que representa el total de puntos a etiquetar (N).\n"
			+ "- Las siguientes N lneas sern tambin nmeros enteros que representan los puntos.\n"
			+ "- Las ltimas N lnea contendrn las anchuras de las etiquetas.\n"
			+ "* No se permiten lneas en blanco ni nmeros separados por espacios.\n";
	
	// problema OC-4P
	
	/**
	 * Constante con el texto que aparece en la cabecera del problema al que se
	 * refiere.
	 */
	public static final String CABECERA_OC_4P = "#######################################################################\n"
			+ "############ EJECUCIN DEL PROBLEMA DE ETIQUETADO OC-4P ###############\n"
			+ "#######################################################################\n";
	
	/**
	 * Constante con la informacin necesaria acerca del problema al que se
	 * refiere.
	 */
	public static final String INFO_OC_4P = "\nDada una lnea oblicua de pendiente positiva, se va a proceder a etiquetar N puntos con\n"
			+ "sus respectivas N etiquetas. Tanto el conjunto de puntos, como el de etiquetas\n"
			+ "sern introducidos ambos por el usuario cuando se solicite por pantalla\n"
			+ "o mediante un fichero de texto que tambin introducir el usuario.\n"
			+ "Para este problema en particular, las etiquetas sern cuadradas,\n"
			+ "debindose situar los puntos sobre uno de los cuatro vrtices de las etiquetas.\n"
			+ "La salida que proporcionar el programa ser una lista de posiciones\n"
			+ "tales que, el primer elemento de la lista corresponder a la posicin\n"
			+ "de la primera etiqueta respecto del primer punto; el segundo elemento\n"
			+ "de la lista de posiciones corresponder a la posicin de la segunda\n"
			+ "etiqueta respecto del segundo punto; y as sucesivamente.\n"
			+ "Las posiciones relativas sern las siguientes:\n"
			+ "     TL -> (Top Left) la etiqueta se sita arriba a la izquierda del punto\n"
			+ "     TR -> (Top Right) la etiqueta se sita arriba a la derecha del punto\n"
			+ "     BL -> (Bottom Left) la etiqueta se sita abajo a la izquierda del punto\n"
			+ "     BL -> (Bottom Right) la etiqueta se sita abajo a la derecha del punto\n"
			+ "Si el problema no tiene solucin, se omitir todo o parte del listado anterior y se indicar\n"
			+ "la imposibilidad de etiquetar sobre los puntos dados.\n";
	
	/**
	 * Constante con la informacin necesaria acerca del formato de un fichero
	 * de entrada de datos para el etiquetado sobre lnea oblicua.
	 */
	public static final String INFO_FICHERO_OC_4P = "Debe crear un fichero de texto y guardarlo con el nombre \"entrada_OC-4P.txt\" en la ubicacin\n"
			+ "donde se encuentra el proyecto. El formato del fichero ser el siguiente:\n"
			+ "- La primera lnea es un nmero entero que representa el total de puntos a etiquetar (N).\n"
			+ "- Las siguientes N lneas sern tambin nmeros enteros que representan los puntos.\n"
			+ "- La ltima lnea ser el tamao (cuadrado) de las etiquetas.\n"
			+ "* No se permiten lneas en blanco ni nmeros separados por espacios.\n";
	
	// problema OR1-4P
	
	/**
	 * Constante con el texto que aparece en la cabecera del problema al que se
	 * refiere.
	 */
	public static final String CABECERA_OR1_4P = "##########################################################################\n"
			+ "############ EJECUCIN DEL PROBLEMA DE ETIQUETADO OR(1)-4P ###############\n"
			+ "##########################################################################\n";
	
	/**
	 * Constante con la informacin necesaria acerca del problema al que se
	 * refiere.
	 */
	public static final String INFO_OR1_4P = "\nDada una lnea oblicua de pendiente positiva, se va a proceder a etiquetar N puntos con\n"
			+ "sus respectivas N etiquetas. Tanto el conjunto de puntos, como el de etiquetas\n"
			+ "sern introducidos ambos por el usuario cuando se solicite por pantalla\n"
			+ "o mediante un fichero de texto que tambin introducir el usuario.\n"
			+ "Para este problema en particular, las etiquetas sern rectangulares,\n"
			+ "debindose situar los puntos sobre uno de los cuatro vrtices de las etiquetas.\n"
			+ "La salida que proporcionar el programa ser una lista de posiciones\n"
			+ "tales que, el primer elemento de la lista corresponder a la posicin\n"
			+ "de la primera etiqueta respecto del primer punto; el segundo elemento\n"
			+ "de la lista de posiciones corresponder a la posicin de la segunda\n"
			+ "etiqueta respecto del segundo punto; y as sucesivamente.\n"
			+ "Las posiciones relativas sern las siguientes:\n"
			+ "     TL -> (Top Left) la etiqueta se sita arriba a la izquierda del punto\n"
			+ "     TR -> (Top Right) la etiqueta se sita arriba a la derecha del punto\n"
			+ "     BL -> (Bottom Left) la etiqueta se sita abajo a la izquierda del punto\n"
			+ "     BL -> (Bottom Right) la etiqueta se sita abajo a la derecha del punto\n"
			+ "Si el problema no tiene solucin, se omitir todo o parte del listado anterior y se indicar\n"
			+ "la imposibilidad de etiquetar sobre los puntos dados.\n";
	
	/**
	 * Constante con la informacin necesaria acerca del formato de un fichero
	 * de entrada de datos para el etiquetado sobre lnea oblicua.
	 */
	public static final String INFO_FICHERO_OR1_4P = "Debe crear un fichero de texto y guardarlo con el nombre \"entrada_OR1-4P.txt\" en la ubicacin\n"
			+ "donde se encuentra el proyecto. El formato del fichero ser el siguiente:\n"
			+ "- La primera lnea es un nmero entero que representa el total de puntos a etiquetar (N).\n"
			+ "- Las siguientes N lneas sern tambin nmeros enteros que representan los puntos.\n"
			+ "- La penltima lnea es otro nmero entero que representa, en este caso, la altura de las etiquetas.\n"
			+ "- La ltima lnea es un nuevo nmero entero que representa la anchura de las etiquetas.\n"
			+ "* No se permiten lneas en blanco ni nmeros separados por espacios.\n";
	
	// problema ORM-4P
	
	/**
	 * Constante con el texto que aparece en la cabecera del problema al que se
	 * refiere.
	 */
	public static final String CABECERA_ORM_4P = "##########################################################################\n"
			+ "############ EJECUCIN DEL PROBLEMA DE ETIQUETADO OR(m)-4P ###############\n"
			+ "##########################################################################\n";
	
	/**
	 * Constante con la informacin necesaria acerca del problema al que se
	 * refiere.
	 */
	public static final String INFO_ORM_4P = "\nDada una lnea oblicua de pendiente positiva, se va a proceder a etiquetar N puntos con\n"
			+ "sus respectivas N etiquetas. Tanto el conjunto de puntos, como el de etiquetas\n"
			+ "sern introducidos ambos por el usuario cuando se solicite por pantalla\n"
			+ "o mediante un fichero de texto que tambin introducir el usuario.\n"
			+ "Para este problema en particular, las etiquetas sern rectangulares,\n"
			+ "debindose situar los puntos sobre uno de los cuatro vrtices de las etiquetas.\n"
			+ "La salida que proporcionar el programa ser una lista de posiciones\n"
			+ "tales que, el primer elemento de la lista corresponder a la posicin\n"
			+ "de la primera etiqueta respecto del primer punto; el segundo elemento\n"
			+ "de la lista de posiciones corresponder a la posicin de la segunda\n"
			+ "etiqueta respecto del segundo punto; y as sucesivamente.\n"
			+ "Las posiciones relativas sern las siguientes:\n"
			+ "     TL -> (Top Left) la etiqueta se sita arriba a la izquierda del punto\n"
			+ "     TR -> (Top Right) la etiqueta se sita arriba a la derecha del punto\n"
			+ "     BL -> (Bottom Left) la etiqueta se sita abajo a la izquierda del punto\n"
			+ "     BL -> (Bottom Right) la etiqueta se sita abajo a la derecha del punto\n"
			+ "Si el problema no tiene solucin, se omitir todo o parte del listado anterior y se indicar\n"
			+ "la imposibilidad de etiquetar sobre los puntos dados.\n";
	
	/**
	 * Constante con la informacin necesaria acerca del formato de un fichero
	 * de entrada de datos para el etiquetado sobre lnea oblicua.
	 */
	public static final String INFO_FICHERO_ORM_4P = "Debe crear un fichero de texto y guardarlo con el nombre \"entrada_ORM-4P.txt\" en la ubicacin\n"
			+ "donde se encuentra el proyecto. El formato del fichero ser el siguiente:\n"
			+ "- La primera lnea es un nmero entero que representa el total de puntos a etiquetar (N).\n"
			+ "- Las siguientes N lneas sern tambin nmeros enteros que representan los puntos.\n"
			+ "- Las N siguientes, ms nmeros enteros que representan, en este caso, la altura de las etiquetas.\n"
			+ "- Las ltimas N lneas son tambin nmeros enteros que representas la anchura de las etiquetas.\n"
			+ "* No se permiten lneas en blanco ni nmeros separados por espacios.\n";
	
	// problema O1R-4P
	
	/**
	 * Constante con el texto que aparece en la cabecera del problema al que se
	 * refiere.
	 */
	public static final String CABECERA_O1R_4P = "########################################################################\n"
			+ "############ EJECUCIN DEL PROBLEMA DE ETIQUETADO O1R-4P ###############\n"
			+ "########################################################################\n";
	
	/**
	 * Constante con la informacin necesaria acerca del problema al que se
	 * refiere.
	 */
	public static final String INFO_O1R_4P = "\nDada una lnea oblicua de pendiente positiva, se va a proceder a etiquetar N puntos con\n"
			+ "sus respectivas N etiquetas. Tanto el conjunto de puntos, como el de etiquetas\n"
			+ "sern introducidos ambos por el usuario cuando se solicite por pantalla\n"
			+ "o mediante un fichero de texto que tambin introducir el usuario.\n"
			+ "Para este problema en particular, las etiquetas sern rectangulares de\n"
			+ "altura unidad y anchura la que se indique, debindose situar\n"
			+ "los puntos sobre uno de los cuatro vrtices de las etiquetas.\n"
			+ "La salida que proporcionar el programa ser una lista de posiciones\n"
			+ "tales que, el primer elemento de la lista corresponder a la posicin\n"
			+ "de la primera etiqueta respecto del primer punto; el segundo elemento\n"
			+ "de la lista de posiciones corresponder a la posicin de la segunda\n"
			+ "etiqueta respecto del segundo punto; y as sucesivamente.\n"
			+ "Las posiciones relativas sern las siguientes:\n"
			+ "     TL -> (Top Left) la etiqueta se sita arriba a la izquierda del punto\n"
			+ "     TR -> (Top Right) la etiqueta se sita arriba a la derecha del punto\n"
			+ "     BL -> (Bottom Left) la etiqueta se sita abajo a la izquierda del punto\n"
			+ "     BL -> (Bottom Right) la etiqueta se sita abajo a la derecha del punto\n"
			+ "Si el problema no tiene solucin, se omitir todo o parte del listado anterior y se indicar\n"
			+ "la imposibilidad de etiquetar sobre los puntos dados.\n";
	
	/**
	 * Constante con la informacin necesaria acerca del formato de un fichero
	 * de entrada de datos para el etiquetado sobre lnea oblicua.
	 */
	public static final String INFO_FICHERO_O1R_4P = "Debe crear un fichero de texto y guardarlo con el nombre \"entrada_O1R-4P.txt\" en la ubicacin\n"
			+ "donde se encuentra el proyecto. El formato del fichero ser el siguiente:\n"
			+ "- La primera lnea es un nmero entero que representa el total de puntos a etiquetar (N).\n"
			+ "- Las siguientes N lneas sern tambin nmeros enteros que representan los puntos.\n"
			+ "- Las N siguientes lneas tambin son nmeros enteros que representan la anchura de las etiquetas."
			+ "- No es necesario indicar la altura de las etiquetas, ya que sern todas de altura unidad.\n"
			+ "* No se permiten lneas en blanco ni nmeros separados por espacios.\n";
	
	// problema OC-4S
	
	/**
	 * Constante con el texto que aparece en la cabecera del problema al que se
	 * refiere.
	 */
	public static final String CABECERA_OC_4S = "#######################################################################\n"
			+ "############ EJECUCIN DEL PROBLEMA DE ETIQUETADO OC-4S ###############\n"
			+ "#######################################################################\n";
	
	/**
	 * Constante con la informacin necesaria acerca del problema al que se
	 * refiere.
	 */
	public static final String INFO_OC_4S = "\nDada una lnea oblicua de pendiente positiva, se va a proceder a etiquetar N puntos con\n"
			+ "sus respectivas N etiquetas. Tanto el conjunto de puntos, como el de etiquetas\n"
			+ "sern introducidos ambos por el usuario cuando se solicite por pantalla\n"
			+ "o mediante un fichero de texto que tambin introducir el usuario.\n"
			+ "Para este problema en particular, las etiquetas sern cuadradas,\n"
			+ "debindose situar los puntos sobre cualquier lado o vrtice de las etiquetas.\n"
			+ "La salida que proporcionar el programa ser una lista de posiciones\n"
			+ "tales que, el primer elemento de la lista corresponder a la posicin\n"
			+ "de la primera etiqueta respecto del primer punto; el segundo elemento\n"
			+ "de la lista de posiciones corresponder a la posicin de la segunda\n"
			+ "etiqueta respecto del segundo punto; y as sucesivamente.\n"
			+ "Las posiciones relativas sern las siguientes:\n"
			+ " TL -> (Top Left) la etiqueta se sita arriba a la izquierda del punto\n"
			+ " TR -> (Top Right) la etiqueta se sita arriba a la derecha del punto\n"
			+ " BL -> (Bottom Left) la etiqueta se sita abajo a la izquierda del punto\n"
			+ " BL -> (Bottom Right) la etiqueta se sita abajo a la derecha del punto\n"
			+ " RR -> (Right) la etiqueta se sita a la derecha del punto\n"
			+ " LL -> (Left) la etiqueta se sita a la izquierda del punto\n"
			+ " TT -> (Top) la etiqueta se sita encima del punto\n"
			+ " BB -> (Bottom) la etiqueta se sita debajo del punto\n"
			+ "Si el problema no tiene solucin, se omitir todo o parte del listado anterior y se indicar\n"
			+ "la imposibilidad de etiquetar sobre los puntos dados.\n";
	
	/**
	 * Constante con la informacin necesaria acerca del formato de un fichero
	 * de entrada de datos para el etiquetado sobre lnea oblicua.
	 */
	public static final String INFO_FICHERO_OC_4S = "Debe crear un fichero de texto y guardarlo con el nombre \"entrada_OC-4P.txt\" en la ubicacin\n"
			+ "donde se encuentra el proyecto. El formato del fichero ser el siguiente:\n"
			+ "- La primera lnea es un nmero entero que representa el total de puntos a etiquetar (N).\n"
			+ "- Las siguientes N lneas sern tambin nmeros enteros que representan los puntos.\n"
			+ "- La ltima lnea ser el tamao (cuadrado) de las etiquetas.\n"
			+ "* No se permiten lneas en blanco ni nmeros separados por espacios.\n";
}
